package com.norco.apicustomertest;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import com.norco.API.NorcoAPI;

public class HWInformationActivity extends AppCompatActivity {

    private Button button1;
    private Button button2;
    private Button button3;
    private Button button4;
    private Button button5;
    private Button button6;
    private Button button7;
    private Button button8;
    private Button button9;
    private Button button10;
    private Button button11;
    private Button button12;
    private Button button13;
    private Button button14;
    private Button button15;
    private Button button16;
    private EditText edt1;
    private EditText edt2;
    private EditText edt3;
    private EditText edt4;
    private EditText edt5;
    private EditText edt6;
    private EditText edt7;
    private EditText edt8;
    private EditText edt9;
    private EditText edt10;
    private EditText edt11;
    private EditText edt12;
    private EditText edt13;
    private EditText edt14;
    private EditText edt15;
    private EditText edt16;


    private static final String TAG = "norcoAPI";
    private NorcoAPI mNorcoAPI = APIApplication.getApplication().getNorcoAPI();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_hwinformation);

        ActionBar actionBar = getSupportActionBar();
        if(actionBar != null){
            actionBar.setHomeButtonEnabled(true);
            actionBar.setDisplayHomeAsUpEnabled(true);
        }

        initView();
        mNorcoAPI.norcoAPIRegister();
        setTitle(R.string.button_hwinformation);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                this.finish(); // back button
                return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mNorcoAPI.norcoAPIUnregister();
    }

    private void initView() {
        button1 = (Button)findViewById(R.id.button1);
        button1.setOnClickListener(getAndroidVersion);

        button2 = (Button)findViewById(R.id.button2);
        button2.setOnClickListener(getDeviceModel);

        button3 = (Button)findViewById(R.id.button3);
        button3.setOnClickListener(getKernelVersion);

        button4 = (Button)findViewById(R.id.button4);
        button4.setOnClickListener(getBuildNumber);

        button5 = (Button)findViewById(R.id.button5);
        button5.setOnClickListener(getCpuCores);

        button6 = (Button)findViewById(R.id.button6);
        button6.setOnClickListener(getCPUMaxFreqKHz);

        button7 = (Button)findViewById(R.id.button7);
        button7.setOnClickListener(getCPUMinFreqKHz);

        button8 = (Button)findViewById(R.id.button8);
        button8.setOnClickListener(getCPUCurFreqKHz);

        button9 = (Button)findViewById(R.id.button9);
        button9.setOnClickListener(getCPUTemp);

        button10 = (Button)findViewById(R.id.button10);
        button10.setOnClickListener(getTotalMem);

        button11 = (Button)findViewById(R.id.button11);
        button11.setOnClickListener(getAvailMem);

        button12 = (Button)findViewById(R.id.button12);
        button12.setOnClickListener(getStorageTotalSize);

        button13 = (Button)findViewById(R.id.button13);
        button13.setOnClickListener(getStorageAvailableSize);

        button14 = (Button)findViewById(R.id.button14);
        button14.setOnClickListener(getUsbStoragePath);

        button15 = (Button)findViewById(R.id.button15);
        button15.setOnClickListener(getSdStoragePath);

        button16 = (Button)findViewById(R.id.button16);
        button16.setOnClickListener(getSerialNum);

        edt1 =(EditText)findViewById(R.id.edt1);
        edt2 =(EditText)findViewById(R.id.edt2);
        edt3 =(EditText)findViewById(R.id.edt3);
        edt4 =(EditText)findViewById(R.id.edt4);
        edt5 =(EditText)findViewById(R.id.edt5);
        edt6 =(EditText)findViewById(R.id.edt6);
        edt7 =(EditText)findViewById(R.id.edt7);
        edt8 =(EditText)findViewById(R.id.edt8);
        edt9 =(EditText)findViewById(R.id.edt9);
        edt10 =(EditText)findViewById(R.id.edt10);
        edt11 =(EditText)findViewById(R.id.edt11);
        edt12 =(EditText)findViewById(R.id.edt12);
        edt13 =(EditText)findViewById(R.id.edt13);
        edt14 =(EditText)findViewById(R.id.edt14);
        edt15 =(EditText)findViewById(R.id.edt15);
        edt16 =(EditText)findViewById(R.id.edt16);

    }

    private View.OnClickListener getAndroidVersion = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button1 getAndroidVersion");
            String androidVersion = mNorcoAPI.hwinfo_getAndroidVersion();
            edt1.setText(androidVersion);
        }
    };

    private View.OnClickListener getDeviceModel = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button2 getDeviceModel");
            String deviceModel = mNorcoAPI.hwinfo_getDeviceModel();
            edt2.setText(deviceModel);
        }
    };

    private View.OnClickListener getKernelVersion = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button3 getKernelVersion");
            String kernelVersion = mNorcoAPI.hwinfo_getKernelVersion();
            edt3.setText(kernelVersion);
        }
    };

    private View.OnClickListener getBuildNumber = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button4 getBuildNumber");
            String buildNumber = mNorcoAPI.hwinfo_getBuildNumber();
            edt4.setText(buildNumber);
        }
    };

    private View.OnClickListener getCpuCores = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button5 getCpuCores");
            int cpuCores = mNorcoAPI.hwinfo_getCpuCores();
            edt5.setText("" +cpuCores);
        }
    };

    private View.OnClickListener getCPUMaxFreqKHz = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button6 getCPUMaxFreqKHz");
            int cpuMaxFreqKHz = mNorcoAPI.hwinfo_getCPUMaxFreqKHz();
            edt6.setText(cpuMaxFreqKHz + "Hz");
        }
    };

    private View.OnClickListener getCPUMinFreqKHz = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button7 getCPUMinFreqKHz");
            int cpuMinFreqKHz = mNorcoAPI.hwinfo_getCPUMinFreqKHz();
            edt7.setText(cpuMinFreqKHz + "Hz");
        }
    };

    private View.OnClickListener getCPUCurFreqKHz = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button8 getCPUCurFreqKHz");
            int cpuCurFreqKHz = mNorcoAPI.hwinfo_getCPUCurFreqKHz();
            edt8.setText(cpuCurFreqKHz + "Hz");
        }
    };

    private View.OnClickListener getCPUTemp = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button9 getCPUTemp");
            int cpuTemp = mNorcoAPI.hwinfo_getCPUTemp();
            edt9.setText(cpuTemp + "℃");
        }
    };

    private View.OnClickListener getTotalMem = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button10 getTotalMem");
            long totalMem = mNorcoAPI.hwinfo_getTotalMem();
            edt10.setText(totalMem + "KB");
        }
    };

    private View.OnClickListener getAvailMem = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button11 getAvailMem");
            long availMem = mNorcoAPI.hwinfo_getAvailMem();
            edt11.setText(availMem + "KB");
        }
    };

    private View.OnClickListener getStorageTotalSize = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button12 getStorageTotalSize");
            long storageTotalSize = mNorcoAPI.hwinfo_getStorageTotalSize();
            edt12.setText(storageTotalSize + "KB");
        }
    };

    private View.OnClickListener getStorageAvailableSize = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button13 getStorageAvailableSize");
            long storageAvailableSize = mNorcoAPI.hwinfo_getStorageAvailableSize();
            edt13.setText(storageAvailableSize + "KB");
        }
    };

    private View.OnClickListener getUsbStoragePath = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button14 getUsbStoragePath");
            String usbStoragePath = mNorcoAPI.hwinfo_getUsbStoragePath();
            edt14.setText(usbStoragePath);
        }
    };

    private View.OnClickListener getSdStoragePath = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button15 getSdStoragePath");
            String sdStoragePath = mNorcoAPI.hwinfo_getSdStoragePath();
            edt15.setText(sdStoragePath);
        }
    };

    private View.OnClickListener getSerialNum = new View.OnClickListener() {
        @Override
        public void onClick(View arg0) {
            Log.i(TAG, "in button16 getSerialNum");
            String serialNum = mNorcoAPI.hwinfo_getSerialNum();
            edt16.setText(serialNum);
        }
    };
}
