package com.norco.apicustomertest;

import android.app.Application;

import com.norco.API.NorcoAPI;

public class APIApplication extends Application {

    private NorcoAPI mNorcoAPI;
    private static APIApplication mApp;

    @Override
    public void onCreate() {
        super.onCreate();
        mApp = this;
        createNorcoAPI();
    }

    public static APIApplication getApplication() {
        return mApp;
    }

    private void createNorcoAPI() {
        mNorcoAPI = NorcoAPI.norcoAPICreate(this);
    }

    public NorcoAPI getNorcoAPI() {
        return mNorcoAPI;
    }
}
